import { CommandPayload, ContainerModule, IClass, ICommand, IContext, IInjector } from "@robotlegsjs/core";
import { IMacro } from "../api/IMacro";
import { ISubCommandMapping } from "../api/ISubCommandMapping";
import { ISubCommandPayload } from "../api/ISubCommandPayload";
import { ISubCommandConfigurator } from "../dsl/ISubCommandConfigurator";
import { AsyncCommand } from "./AsyncCommand";
import { SubCommandMappingList } from "./SubCommandMappingList";
export declare abstract class AbstractMacro extends AsyncCommand implements IMacro {
    protected _injector: IInjector;
    protected _macroPayload: CommandPayload;
    protected _mappings: SubCommandMappingList;
    protected _executeArguments: any;
    protected _commandPayloads: Array<ISubCommandPayload<any>>;
    protected _commandPayloadsModule: ContainerModule;
    constructor(context: IContext, injector: IInjector);
    add(commandClass: IClass<ICommand>): ISubCommandConfigurator;
    remove(commandClass: IClass<ICommand>): void;
    abstract prepare(): void;
    protected captureMacroPayload(executeArguments: any): void;
    protected executeCommand(mapping: ISubCommandMapping): void;
    protected mapMacroPayload(payload: CommandPayload): void;
    protected unmapMacroPayload(payload: CommandPayload): void;
    protected mapPayloads(payloads: Array<ISubCommandPayload<any>>): void;
    protected unmapPayloads(payloads: Array<ISubCommandPayload<any>>): void;
    protected abstract commandCompleteHandler(success: boolean): void;
}
