"use strict";
// ------------------------------------------------------------------------------
//  Copyright (c) 2017-present, RobotlegsJS. All Rights Reserved.
//
//  NOTICE: You are permitted to use, modify, and distribute this file
//  in accordance with the terms of the license agreement accompanying it.
// ------------------------------------------------------------------------------
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var core_1 = require("@robotlegsjs/core");
var AsyncCommand = /** @class */ (function () {
    function AsyncCommand(context) {
        this._listeners = [];
        this._context = context;
        this._context.detain(this);
    }
    AsyncCommand.prototype.registerCompleteCallback = function (listener) {
        this._listeners.unshift(listener);
    };
    AsyncCommand.prototype.dispatchComplete = function (success) {
        this._context.release(this);
        this._listeners.forEach(function (listener) {
            if (listener.length === 0) {
                listener();
            }
            else {
                listener(success);
            }
        });
        this._listeners = null;
    };
    AsyncCommand = tslib_1.__decorate([
        core_1.injectable(),
        tslib_1.__param(0, core_1.inject(core_1.IContext)),
        tslib_1.__metadata("design:paramtypes", [Object])
    ], AsyncCommand);
    return AsyncCommand;
}());
exports.AsyncCommand = AsyncCommand;
//# sourceMappingURL=AsyncCommand.js.map