import { IClass, ICommand, IInjector } from "@robotlegsjs/core";
import { ISubCommandPayload } from "../api/ISubCommandPayload";
import { ISubCommandMapping } from "../api/ISubCommandMapping";
import { ISubCommandConfigurator } from "../dsl/ISubCommandConfigurator";
export declare class SubCommandMapping implements ISubCommandMapping, ISubCommandConfigurator {
    private _commandClass;
    private _guards;
    private _payloads;
    private _hooks;
    constructor(commandClass: IClass<ICommand>);
    readonly commandClass: IClass<ICommand>;
    readonly guards: any[];
    readonly hooks: any[];
    readonly payloads: Array<ISubCommandPayload<any>>;
    withGuards(...guards: any[]): ISubCommandConfigurator;
    withHooks(...hooks: any[]): ISubCommandConfigurator;
    withPayloads(...payloads: any[]): ISubCommandConfigurator;
    getOrCreateCommandInstance(injector: IInjector): ICommand;
}
